package gomod

import (
	"fmt"
	"html/template"
	"net/http"
)
func Index(w http.ResponseWriter, r *http.Request) {
	r.ParseForm()
	t, err := template.ParseFiles("src/payease_transferSingle/view/index.html")
	if err != nil {
		fmt.Fprintf(w, "parse template error: %s", err.Error())
		return
	}
	t.Execute(w, nil)
}
//======================================转账接口======================================================
//转账余额查询
func Balance(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_transferSingle/view/transferSingle/balance.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		BalanceRequest(w,r)
	}
}
//转账订单提交
func TSOrder(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_transferSingle/view/transferSingle/order.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		TSOrderRequest(w,r)
	}
}
//转账异步通知
func TSNotify(w http.ResponseWriter, r *http.Request) {
	TSOrderNotify(w,r) 
}
//转账查询
func TSQuery(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_transferSingle/view/transferSingle/query.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	}else{
		TSQueryRequest(w,r)
	}
}
//模拟异步通知POST数据
func DataPost(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("src/payease_transferSingle/view/post.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	}else{
		PostRequest(w,r)
	}
}