package gomod

import (
	"fmt"
	"net/http"
	"io/ioutil"
	"path/filepath"
	"encoding/json"
	"payease_transferSingle/models"
	"payease_transferSingle/utils"
)
//转账余额查询
func BalanceRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	 apiurl := "https://apis.5upay.com/transferDomestic/account/availableTransferBalance"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_transferSingle/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_transferSingle/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var queryorder models.QueryTSOrder
	 queryorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 queryorder.RequestId = utils.IsNull(r.Form["requestId"])
	  //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(queryorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	queryorder.Hmac = hmac
	orderjson, err := json.Marshal(queryorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,queryorder.MerchantId,queryorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var queryorderback models.AccountAvilableBalanceBack
    json.Unmarshal([]byte(response), &queryorderback)
    rhmac := queryorderback.Hmac
    //fmt.Println("queryorder:", queryorderback)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := queryorderback.Status
    		if status == "SUCCESS"{
    			//fmt.Println("成功:", response)
    			fmt.Fprintf(w, "请求状态成功："+ status)
    			fmt.Fprintf(w, "\n可用余额："+ queryorderback.AvailableTransferBalance)
    			fmt.Fprintf(w, "\n"+ response)
    		}else{
    			//fmt.Println("异常:", response)
    			fmt.Fprintf(w, "请状态异常\n"+ response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("response:", response)
    }
}
//转账订单提交
func TSOrderRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	 apiurl := "https://apis.5upay.com/transferDomestic/single/order"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_transferSingle/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_transferSingle/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var tsorder models.TransferSingleOrder
	 tsorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 tsorder.RequestId = utils.IsNull(r.Form["requestId"])
	 tsorder.Amount = utils.IsNull(r.Form["amount"])
	 tsorder.Currency = utils.IsNull(r.Form["currency"])	 
	 tsorder.NotifyUrl = utils.IsNull(r.Form["notifyUrl"])
	 tsorder.Remark = utils.IsNull(r.Form["remark"])
	
	 var payee models.Payee
	 payee.Name = utils.IsNull(r.Form["name"])
     payee.BankCardNum = utils.IsNull(r.Form["bankCardNum"])
     payee.BankName = utils.IsNull(r.Form["bankName"])
     payee.BranchBankName = utils.IsNull(r.Form["branchBankName"])
     payee.Province = utils.IsNull(r.Form["province"])
     payee.City = utils.IsNull(r.Form["city"])
	 tsorder.Payee=payee
	 fmt.Println("tsorder:",tsorder) 
	 //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(tsorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	tsorder.Hmac = hmac
	orderjson, err := json.Marshal(tsorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,tsorder.MerchantId,tsorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var orderbacks models.TransferSingleOrderBack
    json.Unmarshal([]byte(response), &orderbacks)
    rhmac := orderbacks.Hmac
    //fmt.Println("rhmac:", rhmac)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := orderbacks.Status
    		if status == "SUCCESS"{
    			fmt.Println("提交成功:", status)
    			fmt.Fprintf(w, "提交成功:"+status)
    			fmt.Fprintf(w, "\n"+response)
    		}else{
    			fmt.Println("失败:", status)
    			fmt.Fprintf(w, "提交失败:"+status)
    			fmt.Fprintf(w, "\n"+response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
	    	fmt.Fprintf(w, "验签异常")
	    	fmt.Fprintf(w, "\n"+response)
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, response)
    }
}
//转账异步通知
func TSOrderNotify(w http.ResponseWriter, r *http.Request) {
	//pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_transferSingle/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_transferSingle/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 }
	 r.ParseForm()
	 rpencryptKey := utils.IsNull(r.Header["Encryptkey"])
     if rpencryptKey != "" {		
		aeskey,err := utils.PrivateDecrypt(rpencryptKey, privatepfxpath, pfxpwd)
		if err != nil {
		  fmt.Println("perr:", err)
	   }	
		body, err := ioutil.ReadAll(r.Body)
	   if err != nil {
	     fmt.Println("berr:", err)
	   }  
	   var rback utils.ResponseBack
       json.Unmarshal(body, &rback)
	   ret,err := utils.AesECBDecrypt(rback.Data,aeskey)
	   if err != nil {
		  fmt.Println("aerr:", err)
	   }
	   var orderbacks models.QueryTSOrderBack
		json.Unmarshal([]byte(ret), &orderbacks)
		rhmac := orderbacks.Hmac
		//fmt.Println("rhmac:", rhmac)
		if 	rhmac != ""{
			sortdeldata, oerr := utils.GetDelJson(string(ret),"hmac")
			if oerr != nil {
				fmt.Println("oerr:", oerr)
			} 
			signhm := utils.Sha1(sortdeldata)
			verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
			if verr == nil {
				status := orderbacks.Status
				if status == "SUCCESS"{
					fmt.Fprintf(w, "SUCCESS")
					fmt.Println("SUCCESS")
					fmt.Println("打款成功!")
					fmt.Println("完成时间：",orderbacks.CompleteDateTime)
					fmt.Println("ret:", ret)
				}else if status == "FAILED"{
					fmt.Println("打款失败，请重新发起！:", status)
					fmt.Println("错误信息！:", orderbacks.ErrorMessage)
					fmt.Println("ret:", ret)
				}else if status == "CANCEL"{
					fmt.Println("打款取消，请重新发起:", status)
					fmt.Println("错误信息！:", orderbacks.ErrorMessage)
					fmt.Println("ret:", ret)
				}else{
					fmt.Println("处理异常:", status)
					fmt.Println("ret:", ret)
				}
			}else{
				fmt.Println("verr:", verr)
			}
		}else{
			fmt.Println("response:", ret)
		}
	}else{
		fmt.Println("NO Data")
	}  
	 return
}
//转账查询
func TSQueryRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	 apiurl := "https://apis.5upay.com/transferDomestic/single/query"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_transferSingle/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_transferSingle/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var queryorder models.QueryTSOrder
	 queryorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 queryorder.RequestId = utils.IsNull(r.Form["requestId"])
	  //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(queryorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	queryorder.Hmac = hmac
	orderjson, err := json.Marshal(queryorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,queryorder.MerchantId,queryorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var queryorderback models.QueryTSOrderBack
    json.Unmarshal([]byte(response), &queryorderback)
    rhmac := queryorderback.Hmac
    //fmt.Println("queryorder:", queryorderback)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := queryorderback.Status
    		if status == "SUCCESS"{
				fmt.Println("SUCCESS")
				fmt.Println("转账成功!")
				fmt.Println("完成时间：",queryorderback.CompleteDateTime)
				fmt.Println("response:", response)
				fmt.Fprintf(w, "转账成功:"+status)
				fmt.Fprintf(w, "\n完成时间:"+queryorderback.CompleteDateTime)
    			fmt.Fprintf(w, "\n"+response)
			}else if status == "FAILED"{
				fmt.Println("转账失败，请重新发起:", status)
				fmt.Println("错误信息！:", queryorderback.ErrorMessage)
				fmt.Println("response:", response)
				fmt.Fprintf(w, "转账失败，请重新发起:"+status)
    			fmt.Fprintf(w, "\n"+response)
			}else if status == "CANCEL"{
				fmt.Println("转账取消，请重新发起:", status)
				fmt.Println("错误信息！:", queryorderback.ErrorMessage)
				fmt.Println("response:", response)
				fmt.Fprintf(w, "转账取消，请重新发起:"+status)
    			fmt.Fprintf(w, "\n"+response)
			}else if status == "INIT"{
				fmt.Println("转账待处理:", status)
				fmt.Println("response:", response)
				fmt.Fprintf(w, "转账待处理:"+status)
    			fmt.Fprintf(w, "\n"+response)
			}else if status == "REMITING"{
				fmt.Println("转账中，等待确认:", status)
				fmt.Println("response:", response)
			}else{
				fmt.Println("处理异常:", status)
				fmt.Println("response:", response)
			}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("response:", response)
    }
}