package models

//查询提交
type QueryTSOrder  struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    Hmac string `json:"hmac"`             //参数签名
}
//余额查询响应
type AccountAvilableBalanceBack struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    AvailableTransferBalance string `json:"availableTransferBalance"` //可转账余额单位为分
    DateTime string `json:"dateTime"`   //时间戳
    ResponseObject
}
//转账订单提交
type TransferSingleOrder struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    Amount string `json:"amount"`         //转账金额
    Currency string `json:"currency"`     //转账金额币种
    NotifyUrl string `json:"notifyUrl"`   //通知地址
    Remark string `json:"remark"`         //备注
    Payee Payee `json:"payee"`            //收款人信息
    Hmac string `json:"hmac"`             //参数签名
}

//身份信息
type Payee struct {
    Name  string `json:"name"`                    //收款人姓名
    BankCardNum string `json:"bankCardNum"`       //银行卡号
    BankName  string `json:"bankName"`            //银行名称
    BranchBankName string `json:"branchBankName"` //支行名称
    Province string `json:"province"`             //开户省
    City string `json:"city"`                     //开户市
}
//转账提交响应
type TransferSingleOrderBack struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    ResponseObject
}
//查询响应信息
type QueryTSOrderBack  struct{
	MerchantId string `json:"merchantId"` //商户号
    RequestId string `json:"requestId"`   //订单号
    SerialNumber string `json:"serialNumber"`
    Amount string `json:"amount"`         //转账金额
    Currency string `json:"currency"`     //转账金额币种
    CompleteDateTime string `json:"completeDateTime"`//完成时间
    ErrorMessage string `json:"errorMessage"`//错误信息
    Remark string `json:"remark"`         //备注
    ResponseObject
}